package com.example.vaadinviz.widgetset.client.ui;

import com.google.gwt.dom.client.DivElement;
import com.google.gwt.dom.client.Document;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.visualization.client.AbstractDataTable;
import com.google.gwt.visualization.client.DataTable;
import com.google.gwt.visualization.client.VisualizationUtils;
import com.google.gwt.visualization.client.AbstractDataTable.ColumnType;
import com.google.gwt.visualization.client.visualizations.Table;
import com.google.gwt.visualization.client.visualizations.Table.Options;

public class MyWidget extends Composite {

	protected Label label = new Label("test");
	VerticalPanel vPanel = new VerticalPanel();

	public MyWidget() {
		DivElement div = Document.get().createDivElement();
		div.setId("test");
		setElement(div);

		Runnable onLoadCallback = new Runnable() {

			public void run() {

				// Create a pie chart visualization.
				Table table = new Table(createTable(), createOptions());
				vPanel.add(table);
				vPanel.add(label);
			}
		};

		// Load the visualization api, passing the onLoadCallback to be called
		// when loading is done.
		VisualizationUtils.loadVisualizationApi(onLoadCallback, Table.PACKAGE);

		// Composite GWT widgets must call initWidget().
		initWidget(vPanel);
	}

	private Options createOptions() {
		Options options = Options.create();
		return options;
	}

	private AbstractDataTable createTable() {
		DataTable data = DataTable.create();
		data.addColumn(ColumnType.STRING, "Task");
		data.addColumn(ColumnType.NUMBER, "Hours per Day");
		data.addRows(2);
		data.setValue(0, 0, "Work");
		data.setValue(0, 1, 14);
		data.setValue(1, 0, "Sleep");
		data.setValue(1, 1, 10);
		return data;
	}
}
